
#include "main.h"

void inline printDigit(unsigned char n);
void printNumber8(unsigned char n) ;
void printNumber16(unsigned int n) ;
int Analog (int n);

int main(void)
{

  unsigned char data;

  // Activate ADC with Prescaler 
  ADCSRA =  1 << ADEN  |
            0 << ADSC  |
            0 << ADATE |
            0 << ADIF  |
            0 << ADIE  |
            1 << ADPS2 |
            0 << ADPS1 |
            0 << ADPS0 ;
  
   DDRA = 0x00;    // all ports input  
   DDRB = 0x00;      
   DDRC = 0x00;      
   DDRD = 0x00;      
         
   PORTA = 0x00;   // no pullups   
   PORTB = 0x00;      
   PORTC = 0x00;      
   PORTD = 0x00;                  
                                    
  USART_Init( 12 ); //4800 @ 1Mhz
  USART_printstring("READY.\n\r");
	
    while(1) {

      data = USART_Receive();
      if (data == 0x0D) {
        //USART_printstring("Tempature\n");
        printNumber16(Analog(0));        
        USART_Transmit( 0x0D );
	    USART_Transmit( 0x0A );	
      }
    }

}

void inline printDigit(unsigned char n) {
  USART_Transmit( (n & 0x0F) | 0x30 );
}

void printNumber8(unsigned char n) {
  unsigned char d;
  d = n/100;
  printDigit(d);
  n -= d * 100;
  
  d = n/10;
  printDigit(d);
  n -= d * 10;
  
  printDigit(n);
}

void printNumber16(unsigned int n) {
  unsigned int d;
  
  d = n/10000;
  printDigit(d);
  n -= d * 10000;
  
  d = n/1000;
  printDigit(d);
  n -= d * 1000;
  
  d = n/100;
  printDigit(d);
  n -= d * 100;
  
  d = n/10;
  printDigit(d);
  n -= d * 10;
  
  printDigit(n);
}

int Analog (int n) {

    // Select pin ADC0 using MUX
    ADMUX = n & 7;
    
    //Start conversion
    ADCSRA |= _BV(ADSC);
    
    // wait until converstion completed
    while (ADCSRA & _BV(ADSC) ) {}
    
    // get converted value
    return ADC;  
}
